#ifndef EFL_GENERATED_ELM_INTERFACE_FILESELECTOR_HH
#define EFL_GENERATED_ELM_INTERFACE_FILESELECTOR_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_fileselector.eo.h"
}

#include <string>

struct elm_interface_fileselector;

/// @cond EO_CXX_ABSTRACT
namespace eo_cxx {

struct elm_interface_fileselector
{
   /// @param func 
   /// @param data 
   /// @param filter_name 
   ///
   bool custom_filter_append(Elm_Fileselector_Filter_Func func_, void * data_, ::efl::eina::string_view filter_name_) const;

   void filters_clear() const;

   /// @param mime_types 
   /// @param filter_name 
   ///
   bool mime_types_filter_append(::efl::eina::string_view mime_types_, ::efl::eina::string_view filter_name_) const;

   bool folder_only_get() const;

   void folder_only_set(bool only_) const;

   ::efl::eina::string_view selected_get() const;

   bool selected_set(::efl::eina::string_view path_) const;

   void thumbnail_size_get(Evas_Coord* w_, Evas_Coord* h_) const;

   void thumbnail_size_set(Evas_Coord w_, Evas_Coord h_) const;

   bool hidden_visible_get() const;

   void hidden_visible_set(bool multi_) const;

   Elm_Fileselector_Sort sort_method_get() const;

   void sort_method_set(Elm_Fileselector_Sort sort_) const;

   bool multi_select_get() const;

   void multi_select_set(bool multi_) const;

   bool expandable_get() const;

   void expandable_set(bool expand_) const;

   ::efl::eina::string_view path_get() const;

   void path_set(::efl::eina::string_view path_) const;

   Elm_Fileselector_Mode mode_get() const;

   void mode_set(Elm_Fileselector_Mode mode_) const;

   bool is_save_get() const;

   void is_save_set(bool is_save_) const;

   ::efl::eina::crange_list< ::efl::eina::string_view > selected_paths_get() const;

   ::efl::eina::string_view current_name_get() const;

   void current_name_set(::efl::eina::string_view name_) const;



   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_FILESELECTOR_INTERFACE);
   }

   operator ::elm_interface_fileselector() const;
   operator ::elm_interface_fileselector&();
   operator ::elm_interface_fileselector const&() const;

   /// @cond LOCAL
   template <typename D>
   struct address_of
   {
      operator ::elm_interface_fileselector*() const { return static_cast<::elm_interface_fileselector*>(static_cast<D const*>(this)->p); }
      operator ::elm_interface_fileselector const*() const { return static_cast<::elm_interface_fileselector const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::elm_interface_fileselector const*() const { return static_cast<::elm_interface_fileselector const*>(static_cast<D const*>(this)->p); }
   };
   /// @endcond

private:

   /// @internal
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}
/// @endcond

/// @brief Class elm_interface_fileselector
struct elm_interface_fileselector
      : ::efl::eo::concrete
{
   //@{
   /**
      @brief Constructs a new elm_interface_fileselector object.

      Constructs a new elm_interface_fileselector object. If you want this object to be a child
      of another Eo object, use an @ref efl::eo::parent expression, like the example.

      Example:
      @code
      elm_interface_fileselector my_elm_interface_fileselector(efl::eo::parent = parent_object);
      @endcode

      @see elm_interface_fileselector(Eo* eo)
   */
   explicit elm_interface_fileselector(::efl::eo::parent_type _p)
      : elm_interface_fileselector(_ctors_call(_p))
   {}

   explicit elm_interface_fileselector()
      : elm_interface_fileselector(_ctors_call(::efl::eo::parent = nullptr))
   {}
   //@}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_fileselector(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_fileselector(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_fileselector(elm_interface_fileselector const& other)
      : elm_interface_fileselector(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_fileselector() {}

   /// @param func 
   /// @param data 
   /// @param filter_name 
   ///
   bool custom_filter_append(Elm_Fileselector_Filter_Func func_, void * data_, ::efl::eina::string_view filter_name_) const;

   void filters_clear() const;

   /// @param mime_types 
   /// @param filter_name 
   ///
   bool mime_types_filter_append(::efl::eina::string_view mime_types_, ::efl::eina::string_view filter_name_) const;

   bool folder_only_get() const;

   void folder_only_set(bool only_) const;

   ::efl::eina::string_view selected_get() const;

   bool selected_set(::efl::eina::string_view path_) const;

   void thumbnail_size_get(Evas_Coord* w_, Evas_Coord* h_) const;

   void thumbnail_size_set(Evas_Coord w_, Evas_Coord h_) const;

   bool hidden_visible_get() const;

   void hidden_visible_set(bool multi_) const;

   Elm_Fileselector_Sort sort_method_get() const;

   void sort_method_set(Elm_Fileselector_Sort sort_) const;

   bool multi_select_get() const;

   void multi_select_set(bool multi_) const;

   bool expandable_get() const;

   void expandable_set(bool expand_) const;

   ::efl::eina::string_view path_get() const;

   void path_set(::efl::eina::string_view path_) const;

   Elm_Fileselector_Mode mode_get() const;

   void mode_set(Elm_Fileselector_Mode mode_) const;

   bool is_save_get() const;

   void is_save_set(bool is_save_) const;

   ::efl::eina::crange_list< ::efl::eina::string_view > selected_paths_get() const;

   ::efl::eina::string_view current_name_get() const;

   void current_name_set(::efl::eina::string_view name_) const;



   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_FILESELECTOR_INTERFACE);
   }

   /// @cond LOCAL
   struct address_of
      : ::eo_cxx::elm_interface_fileselector::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::elm_interface_fileselector* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::elm_interface_fileselector::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::elm_interface_fileselector const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

   /// @endcond

private:

   /// @internal
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(ELM_INTERFACE_FILESELECTOR_INTERFACE, _p._eo_raw);

      return _ret_eo;
   }

   /// @internal
   Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::elm_interface_fileselector) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::elm_interface_fileselector>::value, "");


#include "elm_interface_fileselector.eo.impl.hh"

#endif // EFL_GENERATED_ELM_INTERFACE_FILESELECTOR_HH

